/**
 * dropload
 * 西门(http://ons.me/526.html)
 * 0.9.0(160215)
 */

;(function($){
    'use strict';
    var win = window;
    var doc = document;
    var $win = $(win);
    var $doc = $(doc);
    $.fn.dropload = function(options){
        return new MyDropLoad(this, options);
    };
    var MyDropLoad = function(element, options){
        var me = this;
        me.$element = element;
        // 上方是否插入DOM
        me.upInsertDOM = false;
        // loading状态
        me.loading = false;
        // 是否锁定
        me.isLockUp = false;
        me.isLockDown = false;
        // 是否有数据
        me._threshold = 0;
        me.isData = true;
        me._scrollTop = 0;
        me.init(options);
    };

    // 初始化
    MyDropLoad.prototype.init = function(options){
        var me = this;
        me.opts = $.extend(true, {}, {
            scrollArea : me.$element,                                            // 滑动区域
            domUp : {                                                            // 上方DOM
                domClass   : 'dropload-up',
                domRefresh : '<div class="dropload-refresh">↓下拉刷新</div>',
                domUpdate  : '<div class="dropload-update">↑释放更新</div>',
                domLoad    : '<div class="dropload-load"><span class="loading"></span>加载中...</div>'
            },
            domDown : {                                                          // 下方DOM
                domClass   : 'dropload-down',
                domRefresh : '<div class="dropload-refresh">↑上拉加载更多</div>',
                domLoad    : '<div class="dropload-load"><span class="loading"></span>加载中...</div>',
                domNoData  : '<div class="dropload-noData">暂无数据</div>'
            },
            autoLoad : true,                                                     // 自动加载
            distance : 100,                                                       // 拉动距离
            threshold : '',                                                      // 提前加载距离
            loadUpFn : '',                                                       // 上方function
            loadDownFn : ''                                                      // 下方function
        }, options);

        // 如果加载下方，事先在下方插入DOM 
        if(me.opts.loadDownFn != ''){
            // me.$element.append('<div class="ub ub-ac tx-c ub-fh c-wh-pLG bor-k4 umh5 umar-fb3" id="loadDown">'+me.opts.domDown.domRefresh+'</div>');
            me.$domDown = $('#loadDown');
            // me.$domDown.removeClass("hide");
        }
        // 计算提前加载距离
        if(!!me.$domDown && me.opts.threshold === ''){
            // 默认滑到加载区2/3处时加载
            me._threshold = Math.floor(me.$domDown.height()*1/3);
        }else{
            me._threshold = me.opts.threshold;
        }

        // 判断滚动区域
        if(me.opts.scrollArea == win){
            me.$scrollArea = $win;
            // 获取文档高度
            me._scrollContentHeight = $(document).height();
            // 获取win显示区高度  —— 这里有坑
            me._scrollWindowHeight = $(window).height();
        }else{
            me.$scrollArea = me.opts.scrollArea;
            me._scrollContentHeight = me.$element[0].scrollHeight;
            me._scrollWindowHeight = me.$element.height();
        }
        // fnAutoLoad(me);

        // 窗口调整
        $win.on('resize',function(){
            me._scrollContentHeight = $(document).height();
            me._scrollWindowHeight = $(window).height();
            fnAutoLoad(me);
            if(me.opts.scrollArea == win){
                // 重新获取win显示区高度
                me._scrollWindowHeight = win.innerHeight;
            }else{
                me._scrollWindowHeight = me.$element.height();
            }
        });

        // 绑定触摸        
        me.$element.on('touchstart',function(e){
            if(!me.loading){
                fnTouches(e);
                fnTouchstart(e, me);
            }
        });
        me.$element.on('touchmove',function(e){
            if(!me.loading){
                fnTouches(e, me);
                fnTouchmove(e, me);
            }
        });
        me.$element.on('touchend',function(){
            if(!me.loading){
                fnTouchend(me);
            }
        });

        // 加载下方
        me.$scrollArea.on('scroll',function(){
            me._scrollTop = $(window).scrollTop();
            me._scrollContentHeight = $(document).height();
            if (me.direction = 'up') {
                me.$domDown.removeClass("hide");
            };
            // 滚动页面触发加载数据
            if(me.opts.loadDownFn != '' && !me.loading && !me.isLockDown && (me._scrollContentHeight - me._threshold) <= (me._scrollWindowHeight + me._scrollTop)){
                loadDown(me);  
            }
        });
    };

    // touches
    function fnTouches(e){
        if(!e.touches){
            e.touches = e.originalEvent.touches;
        }
    }

    // touchstart
    function fnTouchstart(e, me){
        me._startY = e.touches[0].pageY;
        // 记住触摸时的scrolltop值
        me.touchScrollTop = $(window).scrollTop();
    }

    // touchmove
    function fnTouchmove(e, me){
        me._curY = e.touches[0].pageY;
        me._moveY = me._curY - me._startY;
        if(me._moveY > 0){
            me.direction = 'down';
        }else if(me._moveY < 0){
            me.direction = 'up';
        }
        var _absMoveY = Math.abs(me._moveY);
        // 加载上方

        if(me.opts.loadUpFn != '' && me.touchScrollTop <= 100 && me.direction == 'down' && !me.isLockUp){
            // e.preventDefault();
            me.$domUp = $('#loadUpFn');
            if (me.$domUp.length == 0||!me.$domUp) {
                me.$element.prepend('<div class="ub ub-ac tx-c ub-fh c-wh-pLG bor-k4 umh5 hide" id="loadUpFn"></div>');
                me.$domUp = $('#loadUpFn');
            };

            me.$domUp.removeClass("hide");
            if (me.$domDown) {
                me.$domDown.addClass("hide"); 
            };
            // 如果加载区没有DOM
            if(!me.upInsertDOM){
                // me.$element.prepend('<div class="ub ub-ac tx-c ub-fh c-wh-pLG bor-k4 umh5 umar-fb3" id="loadUpFn"></div>');
                me.upInsertDOM = true;
            }
            // fnTransition(me.$domUp,0);
            // 下拉  
            if(_absMoveY <= me.opts.distance){
                me._offsetY = _absMoveY;
                // appcan.window.openToast({msg:'22222222222222222',duration:6500,position:5,type:0});
                // todo：move时会不断清空、增加dom，有可能影响性能，下同
                me.$domUp.html(me.opts.domUp.domRefresh);
            // 指定距离 < 下拉距离 < 指定距离*2
            }else if(_absMoveY > me.opts.distance && _absMoveY <= me.opts.distance*2){
                // appcan.window.openToast({msg:'22222222222222222',duration:6500,position:5,type:0});
                me._offsetY = me.opts.distance+(_absMoveY-me.opts.distance)*0.5;
                me.$domUp.html(me.opts.domUp.domUpdate);
                // 下拉距离 > 指定距离*2
            }
            
            me.$domUp.css({'height': me._offsetY});
        }
    }

    // touchend
    function fnTouchend(me){
        var _absMoveY = Math.abs(me._moveY);
        if(me.opts.loadUpFn != '' && me.touchScrollTop <= 0 && me.direction == 'down' && !me.isLockUp){
            // fnTransition(me.$domUp,300);
            if(_absMoveY > me.opts.distance){
                me.$domUp.css({'height':me.$domUp.children().height()});
                me.$domUp.html(me.opts.domUp.domLoad);
                me.loading = true;
                setTimeout(function(){
                    me.opts.loadUpFn(me);
                    me.$domUp.addClass("hide");
                },500)
            }else{
                    // me.upInsertDOM = false;
                me.$domUp.addClass("hide");
                // me.$domUp.on('webkitTransitionEnd mozTransitionEnd transitionend',function(){
                // });
            }
            me._moveY = 0;
        }
    }

    // 如果文档高度不大于窗口高度，数据较少，自动加载下方数据
    function fnAutoLoad(me){
        if(me.opts.autoLoad){
            /*if((me._scrollContentHeight - me._threshold) <= me._scrollWindowHeight){
                me.$domDown.addClass("hide");
                // loadDown(me);
            }*/
        }
    }

    // 重新获取文档高度
    function fnRecoverContentHeight(me){
        if(me.opts.scrollArea == win){
            me._scrollContentHeight = $(document).height();
        }else{
            me._scrollContentHeight = me.$element[0].scrollHeight;
        }
    }

    // 加载下方
    function loadDown(me){
        me.direction = 'up';
        me.$domDown.html(me.opts.domDown.domLoad);
        me.loading = true;
        setTimeout(function(){
            me.opts.loadDownFn(me);
            me.$domDown.addClass("hide");
        },1000);
    }

    // 锁定
    MyDropLoad.prototype.lock = function(direction){
        var me = this;
        // 如果不指定方向
        if(direction === undefined){
            // 如果操作方向向上
            if(me.direction == 'up'){
                me.isLockDown = true;
            // 如果操作方向向下
            }else if(me.direction == 'down'){
                me.isLockUp = true;
            }else{
                me.isLockUp = true;
                me.isLockDown = true;
            }
        // 如果指定锁上方
        }else if(direction == 'up'){
            me.isLockUp = true;
        // 如果指定锁下方
        }else if(direction == 'down'){
            me.isLockDown = true;
            // 为了解决DEMO5中tab效果bug，因为滑动到下面，再滑上去点tab，direction=down，所以有bug
            me.direction = 'up';
        }
    };

    // 解锁
    MyDropLoad.prototype.unlock = function(){
        var me = this;
        // 简单粗暴解锁
        me.isLockUp = false;
        me.isLockDown = false;
        // 为了解决DEMO5中tab效果bug，因为滑动到下面，再滑上去点tab，direction=down，所以有bug
        me.direction = 'up';
    };

    // 无数据
    MyDropLoad.prototype.noData = function(flag){
        var me = this;
        if(flag === undefined || flag == true){
            me.isData = false;
        }else if(flag == false){
            me.isData = true;
        }
    };

    // 重置
    MyDropLoad.prototype.resetload = function(){
        var me = this;
        if(me.direction == 'down' && me.upInsertDOM){
                me.loading = false;
                me.upInsertDOM = false;
                me.$domUp.addClass("hide");
                fnRecoverContentHeight(me);
            // me.$domUp.on('webkitTransitionEnd mozTransitionEnd transitionend',function(){
            // });
        }else if(me.direction == 'up'){
            // 如果有数据
            if(me.isData){
                me.loading = false;
                // 加载区修改样式
                // me.$domDown.html(me.opts.domDown.domRefresh);
                fnRecoverContentHeight(me);
                fnAutoLoad(me);
            }else{
                // 如果没数据
                me.$domDown.html(me.opts.domDown.domNoData);
            }
        }
    };

    // css过渡
    function fnTransition(dom,num){
        dom.css({
            '-webkit-transition':'all '+num+'ms',
            'transition':'all '+num+'ms'
        });
    }
})(window.jQuery);