var levels = ['10', '13', '16'];
var zoomnum = 10;
var cityname = GetLS('cityname') ? GetLS('cityname') : '北京';
var map;

window.onload = function() {
    //加载高德js
    JsLoader("http://webapi.amap.com/maps?v=1.3&key=18d41970d23f41ceb6d516876525095c&callback=init&plugin=AMap.Walking,AMap.Driving", function() {});
};
window.init = function() {
    map = new AMap.Map("mapContainer", {
        resizeEnable: true,
        view: new AMap.View2D({
            //center:new AMap.LngLat(locaLng,locaLat),//地图中心点
            zoom: zoomnum //地图显示的缩放级别
        }),
        jogEnable: false
    });

    var inLog = GetLS("inLog") ? GetLS("inLog") : 39.865042;
    var inLat = GetLS("inLat") ? GetLS("inLat") : 116.379028;
    var storeItem = GetLS("pathPlan_store");

    var type = GetLS("pathPlan_type");
        if (type == "walk") {
            $('.walk').css({
                'background': 'url("./district_content/css/myImg/blueMan.png")',
                'background-repeat': 'no-repeat',
                'background-size': 'contain',
                '-webkit-background-size': 'contain'
            });
            $('.by-car').css({
                'background': 'url("./district_content/css/myImg/grayCar.png")',
                'background-repeat': 'no-repeat',
                'background-size': 'contain',
                '-webkit-background-size': 'contain'
            });

        }else{
            $('.by-car').css({
                'background': 'url("./district_content/css/myImg/byCar.png")',
                'background-repeat': 'no-repeat',
                'background-size': 'contain',
                '-webkit-background-size': 'contain'
            });
            $('.walk').css({
                'background': 'url("./district_content/css/myImg/walk.png")',
                'background-repeat': 'no-repeat',
                'background-size': 'contain',
                '-webkit-background-size': 'contain'
            });
        };

    setTimeout(function() {
        if (type == "walk") {
            walking(inLog, inLat, storeItem.x, storeItem.y);
        }else{
            driving(inLog, inLat, storeItem.x, storeItem.y);
        };
    },1000);
}

//清空地图
function clearMap() {
    map.clearMap();
}
//距离
function distance(distance) {
    if (distance < 1000 && distance >= 0)
        return distance + '米';
    else if (distance >= 1000)
        return (distance / 1000).toFixed(2) + '公里';
    else
        return '';
}
//时间
function time(time) {
    var s = time;
    var m = parseInt(time / 60);
    var h = parseInt(time / 60 / 60);
    if (h > 0 && m > 0) {
        return h + '小时' + (m - h * 60) + '分钟';
    } else if (h > 0 && m <= 0) {
        return h + '小时';
    } else if (m > 0) {
        return m + '分钟';
    } else {
        return '';
    }
}
//驾车路线
function driving(startX, startY, endX, endY) {
    clearMap();
    map.setZoomAndCenter(levels[2], [startX, startY]);
    //起、终点
    var start_xy = new AMap.LngLat(startX, startY);
    var end_xy = new AMap.LngLat(endX, endY);
    // var start_xy = [startY, startX];
    // var end_xy = [endX, endY];
    var DrivingOption = {
        //驾车策略，包括 LEAST_TIME，LEAST_FEE, LEAST_DISTANCE,REAL_TRAFFIC
        policy: AMap.DrivingPolicy.LEAST_TIME,
        map: map,
        panel: 'panel'
    };
    var MDrive = new AMap.Driving(DrivingOption); //构造驾车导航类
    AMap.event.addListener(MDrive, "complete", driving_routeCallBack); //返回导航查询结果
    MDrive.search(start_xy, end_xy); //根据起终点坐标规划驾车路线
}
//驾车路线结果展示
function driving_routeCallBack(data) {
    resultShow(data);
}
//步行路线
function walking(startX, startY, endX, endY) {
    clearMap();
    map.setZoomAndCenter(levels[2], [startX, startY]);
    var start_xy = new AMap.LngLat(startX, startY);
    var end_xy = new AMap.LngLat(endX, endY);
    var DrivingOption = {
        map: map,
        panel: 'panel'
    };
    var MWalk = new AMap.Walking(DrivingOption); //构造路线导航类
    AMap.event.addListener(MWalk, "complete", walk_routeCallBack); //返回导航查询结果
    MWalk.search(start_xy, end_xy); //根据起终点坐标规划步行路线
}
//步行路线结果展示
function walk_routeCallBack(data) {
    resultShow(data);
}
//结果展示
function resultShow(data) {
    var routeS = data.routes[0];
    var stepsHtml = '';
    var flag = true;
    var stepsNum = 0;
    var stepsNumSum = (function() {
        var num = 0;
        for (var i = 0; i < routeS.steps.length; i++) {
            if (routeS.steps[i].road != '') {
                num++;
            }
        }
        return num;
    })();
    $("#time").text(time(routeS.time));
    $("#distance").text(distance(routeS.distance));
    for (var i = 0; i < routeS.steps.length; i++) {
        if (routeS.steps[i].road != '') {
            stepsNum++;
            if (stepsNum <= 2) {
                stepsHtml += routeS.steps[i].road + ' → ';
                continue;
            }
            if (stepsNumSum - stepsNum > 2 && flag) {
                flag = false;
                stepsHtml += ' ......  → ';
                continue;
            }
            if (stepsNum > 2 && stepsNumSum - stepsNum == 1) {
                stepsHtml += routeS.steps[i].road + ' → ';
                continue;
            }
            if (stepsNumSum == stepsNum) {
                stepsHtml += routeS.steps[i].road;
                continue;
            }
        }
    }
    $('.route-path').text(stepsHtml);
}

appcan.button("#fh-btn", "btn-act", function() {
    // if(ifSameFolder() == '../')
    //     appcan.window.evaluateScript(ifSameFolder()+'map/pathPlan', 'closeWindow()');
    // else
        appcan.window.evaluateScript('pathPlan', 'closeWindow()');
})
appcan.button("#showPlan", "btn-act", function() {
    $('.panel-wrapper').css('display', 'block');
})

appcan.button(".by-car", "btn-act", function() {
    $('.by-car').css({
        'background': 'url("./district_content/css/myImg/byCar.png")',
        'background-repeat': 'no-repeat',
        'background-size': 'contain',
        '-webkit-background-size': 'contain'
    });
    $('.walk').css({
        'background': 'url("./district_content/css/myImg/walk.png")',
        'background-repeat': 'no-repeat',
        'background-size': 'contain',
        '-webkit-background-size': 'contain'
    });
    var inLat = GetLS("inLat") ? GetLS("inLat") : 116.379028;
    var inLog = GetLS("inLog") ? GetLS("inLog") : 39.865042;
    var storeItem = GetLS("pathPlan_store");
    driving(inLog, inLat, storeItem.x, storeItem.y);
})

appcan.button(".walk", "btn-act", function() {
    $('.by-car').css({
        'background': 'url("./district_content/css/myImg/grayCar.png")',
        'background-repeat': 'no-repeat',
        'background-size': 'contain',
        '-webkit-background-size': 'contain'
    });
    $('.walk').css({
        'background': 'url("./district_content/css/myImg/blueMan.png")',
        'background-repeat': 'no-repeat',
        'background-size': 'contain',
        '-webkit-background-size': 'contain'
    });
    var inLat = GetLS("inLat") ? GetLS("inLat") : 116.379028;
    var inLog = GetLS("inLog") ? GetLS("inLog") : 39.865042;
    var storeItem = GetLS("pathPlan_store");
    walking(inLog, inLat, storeItem.x, storeItem.y);
})

//绑定定位当前位置
appcan.button("#ser_btn", "btn-act", function() {
    var inLat = GetLS("inLat") ? GetLS("inLat") : 0;
    var inLog = GetLS("inLog") ? GetLS("inLog") : 0;
    if (inLat != 0 && inLog != 0) {
        map.setZoomAndCenter(levels[2], [inLog, inLat]);
    } else {
        appcan.window.openToast({
            msg: '未获取到当前GPS坐标,无法定位到附近小区......',
            duration: 2000,
            position: 5,
            type: 0
        });
    }
})
